unit FMain;
//  If you are using Delphi 6 Enterprise then disable this compiler directive :
{$DEFINE MyXML}
//  NOTE: Don't forget to apply the same change to Demo4Settings.pas

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DBCtrls, DataList, Spin;

type
  TfrmMain = class(TForm)
    panUsers: TGroupBox;
    butAdd: TButton;
    butDelete: TButton;
    butExit: TButton;
    labUserName: TLabel;
    edUserName: TEdit;
    panSettings: TGroupBox;
    edStr: TEdit;
    lstUsers: TListBox;
    edInt: TSpinEdit;
    labStr: TLabel;
    labInt: TLabel;
    chkBool: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure butAddClick(Sender: TObject);
    procedure butDeleteClick(Sender: TObject);
    procedure edStrChange(Sender: TObject);
    procedure lstUsersClick(Sender: TObject);
    procedure butExitClick(Sender: TObject);
    procedure edIntChange(Sender: TObject);
    procedure chkBoolClick(Sender: TObject);
  private
    Table : TDataList;  //  Pretend this is a table (not all users have Delphi Professional)
    procedure ShowDataList;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

uses
{$IFDEF MyXML}
  MyXML,
{$ELSE}
  XMLDoc,
{$ENDIF}
  Demo4Settings, Demos;

{ TfrmMain }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  //  Open the "table"
  Table := TDataList.Create;
  Table.LoadFromFile( FileName('.txt') );
  //  Show on screen
  ShowDataList;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  //  Close the "table"
  Table.SaveToFile( FileName('.txt') );
  Table.Free;
end;

procedure TfrmMain.butExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.ShowDataList;
var
  i : integer;
begin
  lstUsers.Items.Clear;
  for i := 0 to Table.Count-1 do
    lstUsers.Items.AddObject( Table[i].Login, Table[i] );
end;

procedure TfrmMain.lstUsersClick(Sender: TObject);
var
  Rec : TDataElem;
begin
  //  Get the selected "record" from the "table"
  Rec := lstUsers.Items.Objects[ lstUsers.ItemIndex ] as TDataElem;
  //  Have the Storage use these settings
{$IFDEF MyXML}
  Storage.XMLDocument.AsString  := Rec.XML;
{$ELSE}
  Storage.XMLDocument.LoadFromXML( Rec.XML );
{$ENDIF}
  //  Transfer these settings to the UserSettings object
  Storage.LoadAll( UserSettings );
  //  Make use of the settings (in this application simply show their values)
  edStr.Text      := UserSettings.Str;
  edInt.Value     := UserSettings.Int;
  chkBool.Checked := UserSettings.Bool;
  //
  edUserName.Text := Rec.Login;
end;

procedure TfrmMain.butAddClick(Sender: TObject);
begin
  //  Make sure the Storage has the settings
  Storage.SaveAll( UserSettings );
  //  Save the settings to the "table"
{$IFDEF MyXML}
  Table.Update( edUserName.Text, Storage.XMLDocument.AsString );
{$ELSE}
  Table.Update( edUserName.Text, Storage.XMLDocument.XML.Text );
{$ENDIF}
  //
  ShowDataList;
end;

procedure TfrmMain.butDeleteClick(Sender: TObject);
begin
  //  Delete the settings record from the "table"
  Table.Delete( edUserName.Text );
  //
  ShowDataList;
end;

procedure TfrmMain.edStrChange(Sender: TObject);
begin
  //  Store the setting
  UserSettings.Str  := edStr.Text;
end;

procedure TfrmMain.edIntChange(Sender: TObject);
begin
  //  Store the setting
  UserSettings.Int  := edInt.Value;
end;

procedure TfrmMain.chkBoolClick(Sender: TObject);
begin
  //  Store the setting
  UserSettings.Bool := chkBool.Checked;
end;

end.
